<?php
/*
 +-------------------------------------------------------------------------+
 | Copyright (C) 2004-2008 The Cacti Group                                 |
 |                                                                         |
 | This program is free software; you can redistribute it and/or           |
 | modify it under the terms of the GNU General Public License             |
 | as published by the Free Software Foundation; either version 2          |
 | of the License, or (at your option) any later version.                  |
 |                                                                         |
 | This program is distributed in the hope that it will be useful,         |
 | but WITHOUT ANY WARRANTY; without even the implied warranty of          |
 | MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the           |
 | GNU General Public License for more details.                            |
 +-------------------------------------------------------------------------+
 | Cacti: The Complete RRDTool-based Graphing Solution                     |
 +-------------------------------------------------------------------------+
 | This code is designed, written, and maintained by the Cacti Group. See  |
 | about.php and/or the AUTHORS file for specific developer information.   |
 +-------------------------------------------------------------------------+
 | http://www.cacti.net/                                                   |
 +-------------------------------------------------------------------------+
*/

function plugin_init_gpsmap() {
    // This is where you hook into the plugin archetecture
    global $plugin_hooks;
    $plugin_hooks['draw_navigation_text']['gpsmap'] = 'gpsmap_draw_navigation_text';
    $plugin_hooks['api_device_save']['gpsmap'] = 'gpsmap_api_device_save';
    $plugin_hooks['config_arrays']['gpsmap'] = 'gpsmap_config_arrays';
    $plugin_hooks['config_settings']['gpsmap'] = 'gpsmap_config_settings';
    $plugin_hooks['top_header_tabs']['gpsmap'] = 'gpsmap_show_tab';	
    $plugin_hooks['config_form']['gpsmap'] = 'gpsmap_config_form';
}

function plugin_gpsmap_install () {
	api_plugin_register_hook('gpsmap', 'config_arrays',         'gpsmap_config_arrays',        'setup.php');
	api_plugin_register_hook('gpsmap', 'draw_navigation_text',  'gpsmap_draw_navigation_text', 'setup.php');
	api_plugin_register_hook('gpsmap', 'api_device_save',       'gpsmap_api_device_save', 	   'setup.php');
	api_plugin_register_hook('gpsmap', 'config_settings',       'gpsmap_config_settings',      'setup.php');
	api_plugin_register_hook('gpsmap', 'top_header_tabs',       'gpsmap_show_tab',             'setup.php');
	api_plugin_register_hook('gpsmap', 'config_form', 	    'gpsmap_config_form',          'setup.php');
	
	api_plugin_register_realm('gpsmap', 'gpsmap.php', 'GPS Mapping', 1);

	gpsmap_setup_database();
}


function gpsmap_version () {
    return array( 
	    'name'      => 'gpsmap',    
            'version'   => '1.36',     
            'longname'  => 'GPS Mapping based on Lat and Long values for each host',
            'author'    => 'Andy Aloia',
            'homepage'  => 'http://www.esatech.com',
            'email' 	=> 'aaloia@esatech.com',
            'url'      	=> 'http://www.esatech.com'
            );
}
function plugin_gpsmap_uninstall () {
	gpsmap_remove_database();
}        
function plugin_gpsmap_check_config () {
	/* Here we will check to ensure everything is configured */
	gpsmap_check_upgrade ();
	return true;
}

function plugin_gpsmap_upgrade () {
	/* Here we will upgrade to the newest version */
	gpsmap_check_upgrade ();
	return false;
} 
 
function plugin_gpsmap_version () {
	return gpsmap_version();
}

function gpsmap_check_upgrade () {
	/* Let's only run this check if we are on a page
	   that actually needs the data */
}

function gpsmap_check_dependencies() {
	global $plugins, $config;
	return true;
} 

function gpsmap_setup_database() {
	global $config, $database_default;
	include_once($config["library_path"] . "/database.php");
		
	$sql = "ALTER TABLE host ADD COLUMN latitude float(13,10);";
	$result = mysql_query($sql) or die (mysql_error());
	$sql = "ALTER TABLE host ADD COLUMN longitude float(13,10);";
	$result = mysql_query($sql) or die (mysql_error());
	$sql = "INSERT INTO `user_auth_realm` VALUES (84, 1)";
	$result = mysql_query($sql); // or die (mysql_error());
} 

function gpsmap_remove_database() {
	global $config, $database_default;
	include_once($config["library_path"] . "/database.php");
		
	$sql = "ALTER TABLE host DROP COLUMN latitude;";
	$result = mysql_query($sql) or die (mysql_error());
	$sql = "ALTER TABLE host DROP COLUMN longitude;";
	$result = mysql_query($sql) or die (mysql_error());
	$sql = "DELETE FROM `user_auth_realm` WHERE realm_id = 84";
	$result = mysql_query($sql); // or die (mysql_error());
}   

function gpsmap_config_arrays () {
    global $user_auth_realms, $user_auth_realm_filenames;
   
    $user_auth_realms[84]='gpsmap';
    $user_auth_realm_filenames['gpsmap.php'] = 84;
}



function gpsmap_config_settings () {
//this puts the following form elements on the Settings->Misc tab in cacti
    global $tabs, $settings;
    $tabs["gpsmap"] = "GPS Map";

    $temp = array(
        "gpsmap_header" => array(
            "friendly_name" => "GPS Map",
            "method" => "spacer",
            ),
        "gpsmap_apikey" => array(
            "friendly_name" => "Google API Key",
            "description" => "Requires a google API Key, get one here http://code.google.com/apis/maps/",
            "method" => "textbox",
            "max_length" => 100,
            ),
	 "gpsmap_latutude" => array(
            "friendly_name" => "Initial Latitude",
            "description" => "Defines the centering of the map",
            "method" => "textbox",
            "max_length" => 12,
            ),
	  "gpsmap_longitude" => array(
            "friendly_name" => "Initial Longitude",
            "description" => "Defines the centering of the map",
            "method" => "textbox",
            "max_length" => 12,
            ),
	  "gpsmap_zoom" => array(
            "friendly_name" => "Initial elevation",
            "description" => "Defines the elevation of the map from 0 - 12",
            "method" => "textbox",
            "max_length" => 2,
            ),
	  "gpsmap_height" => array(
            "friendly_name" => "Map height",
            "description" => "Defines the map size in height (cannot be 100%)",
            "method" => "textbox",
            "max_length" => 4,
            ),
	   "gpsmap_spacer" => array(
            "friendly_name" => "Overlay Settings",
            "method" => "spacer",
            ),
	  "gpsmap_towerhostid" => array(
            "friendly_name" => "Tower HostID",
            "description" => "This is the host_template_ID that is defined as being a Tower",
            "method" => "textbox",
            "max_length" => 2,
            ),
	  "gpsmap_fillcolor" => array(
            "friendly_name" => "Fill Color",
            "description" => "The overlay circle fill color as FFFFFF",
            "method" => "textbox",
            "max_length" => 7,
            ),
	  "gpsmap_licolor" => array(
            "friendly_name" => "Ring Color",
            "description" => "Defines the outer rim color as FFFFFF",
            "method" => "textbox",
            "max_length" => 7,
            ),
	  "gpsmap_liwidth" => array(
            "friendly_name" => "Ring Width",
            "description" => "Outter Ring width",
            "method" => "textbox",
            "max_length" => 7,
            ),	  
	"gpsmap_fillopa" => array(
            "friendly_name" => "Fill Opacity",
            "description" => "Defines the fill opacity between 0 and 1",
            "method" => "textbox",
            "max_length" => 2,
            ),
	"gpsmap_liopa" => array(
            "friendly_name" => "Ring Opacity",
            "description" => "Defines the ring opacity between 0 and 1",
            "method" => "textbox",
            "max_length" => 2,
            ),
	"gpsmap_circlequality" => array(
            "friendly_name" => "Quality",
            "description" => "number of divisions in circle (preferably >10)",
            "method" => "textbox",
            "max_length" => 3,
            ),

    );
    if (isset($settings["gpsmap"]))
        $settings["gpsmap"] = array_merge($settings["gpsmap"], $temp);
    else
        $settings["gpsmap"]=$temp;
}

function gpsmap_draw_navigation_text ($nav) {
   $nav["gpsmap.php:"] = array("title" => "GPS Map", "mapping" => "index.php:", "url" => "gpsmap.php", "level" => "1");
  
   return $nav;
}


function gpsmap_api_device_save ($save) {
    if (isset($_POST['latitude']))
        $save['latitude'] = form_input_validate($_POST['latitude'], 'latitude', '', true, 3);
    else
        $save['latitude'] = form_input_validate('', 'latitude', '', true, 3);
	
    if (isset($_POST['longitude']))
        $save['longitude'] = form_input_validate($_POST['longitude'], 'longitude', '', true, 3);
    else
        $save['longitude'] = form_input_validate('', 'longitude', '', true, 3);
	    
    return $save;
}


function gpsmap_authorized() {
	if (sizeof(db_fetch_assoc("SELECT realm_id 
		FROM user_auth_realm 
		WHERE user_id=" . $_SESSION["sess_user_id"] . "
		AND realm_id IN (84)"))) {
		return true;
	}else{
		return false;
	}
}
function gpsmap_show_tab() {
	global $config;

	if (gpsmap_authorized()) {
			print '<a href="' . $config['url_path'] . 'plugins/gpsmap/gpsmap.php"><img src="' . $config['url_path'] . 'plugins/gpsmap/images/tab_gpsmap.png" alt="Mapping" align="absmiddle" border="0"></a>';
		}
}

//defines latitude and longitude for devices
function gpsmap_config_form () {
	global $fields_host_edit;
	$fields_host_edit2 = $fields_host_edit;
	$fields_host_edit3 = array();
	foreach ($fields_host_edit2 as $f => $a) {
		$fields_host_edit3[$f] = $a;
		if ($f == 'disabled') {
			$fields_host_edit3['latitude'] = array(
				'friendly_name' => 'Latitude',
				'description' => 'The devices latitude coordinates',
				'method' => 'textbox',
				'max_length' => 13,
				'value' => '|arg1:latitude|',
				'default' => '',
			);
			$fields_host_edit3['longitude'] = array(
				'friendly_name' => 'Longitude',
				'description' => 'The devices longitude coordinates',
				'method' => 'textbox',
				'max_length' => 13,
				'value' => '|arg1:longitude|',
				'default' => '',
			);
						
		} 
	}
	$fields_host_edit = $fields_host_edit3;
}

?>